#include <jni.h>
#include <vector>
using namespace std;

extern "C" {
jintArray
Java_com_AndroidLPupload_AndroidLPuploadActivity_LpFilterJNI(JNIEnv* env, jobject thiz , jintArray pixels, jint w, jint h)
{
	// create a C++ 2D-array from the 1D-jintArray; extract the RGB values
	jint *CPixels = env->GetIntArrayElements(pixels, 0);
    vector<vector<int> > array(3*w, vector<int>(h));

    int temp=0;
	for(int j=0; j<h; j++)
	   for(int i=0; i<(w*3); i=i+3)
		{
			temp = CPixels[i/3+j*w];
			array[i][j] = (temp >> 16) & 0xff;		// transparency is lost
			array[i+1][j] = (temp >> 8) & 0xff;
			array[i+2][j] = (temp) & 0xff;
		}
	env->ReleaseIntArrayElements(pixels, CPixels, 0);

    // filtering //
    vector<vector<int> > array2 = array;

    // Gaussian filter
    //double filterMatrix[3][3]={{1,2,1},{2,4,2},{1,2,1}};
    double filterMatrix[5][5]={{1,4,7,4,1},{4,16,26,16,4},{7,26,41,26,7},{4,16,26,16,4},{1,4,7,4,1}};
    for(int i=0; i<5; i++)
        for(int j=0; j<5; j++)
            filterMatrix[i][j] = filterMatrix [i][j]/273;

    int filterWidth = sizeof(filterMatrix) / sizeof(filterMatrix[0]);
    int filterWidthHalf = (filterWidth/2);
    double newPixelValue;

    for(int i=3*filterWidthHalf; i<(3*w-3*filterWidthHalf); i++)
    {
        for(int j=filterWidthHalf; j<(h-filterWidthHalf); j++)
        {
            newPixelValue = 0;
            for(int k=-filterWidthHalf; k<=filterWidthHalf; k++)
            {
                for(int n=-filterWidthHalf; n<=filterWidthHalf; n++)
                {
                    newPixelValue += ((double)array[i+3*k][j+n])*filterMatrix[filterWidthHalf+k][filterWidthHalf+n];
                }
            }
            array2[i][j] = (255<newPixelValue+0.5)?255:(newPixelValue<0)?0:newPixelValue;
        }
    }

	for(int j=0; j<h; j++)
		for(int i=0; i<(w*3); i=i+3)
		{
			CPixels[i/3+j*w] = (array2[i][j]<<16) + (array2[i+1][j]<<8) + (array2[i+2][j]);
		}
	env->SetIntArrayRegion((jintArray)pixels,(jsize)0,h,(jint *)CPixels);

   return pixels;
}
}
