package com.AndroidLPupload;

import java.io.File;

import android.app.Activity;
import android.content.Intent;
import android.database.Cursor;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.net.Uri;
import android.os.Bundle;
import android.provider.MediaStore;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.ImageView;

public class AndroidLPuploadActivity extends Activity {
	private ImageView imgView;
    private Button changeButton, loadButton, cameraButton;
    private Bitmap bmp, bmp2;
    private boolean original;
    private String last_image, PROJECT_DIR = "/sdcard/Images_App/";
    private int CAMERA_PIC_REQUEST = 0, LOAD_PIC_REQUEST = 1;
    private Uri currImageURI;
    
    private static native int[] LpFilterJNI(int[] in_array, int width, int height);
	static
	{
		System.loadLibrary("LowpassJNI");
	}

    
    @Override
    public void onCreate(Bundle savedInstanceState) {
    	 super.onCreate(savedInstanceState);
         setContentView(R.layout.main);

         loadButton = (Button)findViewById(R.id.load_button);
         loadButton.setOnClickListener(new OnClickListener() {
	       	public void onClick(View v) {
	    		Intent intent = new Intent();
	    		intent.setType("image/*");
	    		intent.setAction(Intent.ACTION_GET_CONTENT);
	    		startActivityForResult(Intent.createChooser(intent, "Select Picture"),LOAD_PIC_REQUEST);
	    		}
	 	  	});  
         
         cameraButton = (Button)findViewById(R.id.camera_button);   
         cameraButton.setOnClickListener(new OnClickListener() {
 	    	public void onClick(View v) {
 	    		 last_image = PROJECT_DIR + "tmp_" + System.currentTimeMillis() + ".jpg";
                 Intent cameraIntent = new Intent(android.provider.MediaStore.ACTION_IMAGE_CAPTURE);
                 cameraIntent.putExtra(
                         android.provider.MediaStore.EXTRA_OUTPUT,
                         Uri.fromFile(new File(last_image)));
                 startActivityForResult(cameraIntent, CAMERA_PIC_REQUEST);
 	    	}
 	 	  	});   
    }
    
    public void picChosen() {
    	setContentView(R.layout.design);
    	imgView = (ImageView)findViewById(R.id.ImageView01);
    	bmp = decodeFile(last_image);
        imgView.setImageBitmap(bmp);
        bmp2 = null;
        original = true;
        	
	   	 changeButton = (Button)findViewById(R.id.change_button);   
	        changeButton.setOnClickListener(new OnClickListener() {
		    	public void onClick(View v) {
		            if (original) {
		                if (bmp2==null) {
		 	            	int w = bmp.getWidth();
		 	                int h = bmp.getHeight(); 
		 	               
		 	                int pixels[] = new int[w*h];
		 	                bmp.getPixels(pixels, 0, w, 0, 0, w, h);
		 	                
		 	    		    pixels = LpFilterJNI(pixels,w,h);
		 	    		    bmp2 = Bitmap.createBitmap(w, h, bmp.getConfig());
		 	    		    bmp2.setPixels(pixels, 0, w, 0, 0, w, h);
		                }
		 	                imgView.setImageBitmap(bmp2);
		 	                changeButton.setText(getString(R.string.change_button_2));
		 	    	        original = false;
		            }
	               else {
		               	imgView.setImageBitmap(bmp);
		                changeButton.setText(getString(R.string.change_button_1));
		    	        original = true;
		            }
		    	}
		    });
	      
         loadButton = (Button)findViewById(R.id.load_button);
         loadButton.setOnClickListener(new OnClickListener() {
	       	public void onClick(View v) {
	    		Intent intent = new Intent();
	    		intent.setType("image/*");
	    		intent.setAction(Intent.ACTION_GET_CONTENT);
	    		startActivityForResult(Intent.createChooser(intent, "Select Picture"),LOAD_PIC_REQUEST);
	    		}
	 	  	}); 
        
	      cameraButton = (Button)findViewById(R.id.camera_button);   
	      cameraButton.setOnClickListener(new OnClickListener() {
		    	public void onClick(View v) {
		    		 last_image = PROJECT_DIR + "tmp_" + System.currentTimeMillis() + ".jpg";
	              Intent cameraIntent = new Intent(android.provider.MediaStore.ACTION_IMAGE_CAPTURE);
	              cameraIntent.putExtra(
	                      android.provider.MediaStore.EXTRA_OUTPUT,
	                      Uri.fromFile(new File(last_image)));
	              startActivityForResult(cameraIntent, CAMERA_PIC_REQUEST);
		    	}
		 	  	});
	}
    
    
    @Override
    public void onActivityResult(int requestCode, int resultCode, Intent data) {
        if (resultCode == Activity.RESULT_OK) {
        	if(requestCode == CAMERA_PIC_REQUEST) {
        		picChosen();
        	}
        if (requestCode == LOAD_PIC_REQUEST) {
        	currImageURI = data.getData();

            String [] proj={MediaStore.Images.Media.DATA};
            Cursor cursor = managedQuery( currImageURI,
                            proj, // Which columns to return
                            null,       // WHERE clause; which rows to return (all rows)
                            null,       // WHERE clause selection arguments (none)
                            null); // Order-by clause (ascending by name)
            int column_index = cursor.getColumnIndexOrThrow(MediaStore.Images.Media.DATA);
            cursor.moveToFirst();
	    	last_image = cursor.getString(column_index);
	    	picChosen();
        }
        }
    }
    
    
  //decodes image and scales it to reduce memory consumption
    private Bitmap decodeFile(String path){
            //Decode image size
            BitmapFactory.Options options = new BitmapFactory.Options();
            options.inJustDecodeBounds = true;
            BitmapFactory.decodeFile(path, options);
            //The new size we want to scale to
            final int REQUIRED_SIZE=250;

            //Find the correct scale value. It should be the power of 2.
            int width_tmp=options.outWidth, height_tmp=options.outHeight;
            int scale=1;
            while(true){
                if(width_tmp/2<REQUIRED_SIZE || height_tmp/2<REQUIRED_SIZE)
                    break;
                width_tmp/=2;
                height_tmp/=2;
                scale*=2;
            }

            //Decode with inSampleSize
            BitmapFactory.Options options2 = new BitmapFactory.Options();
            options2.inSampleSize=scale;
            return BitmapFactory.decodeFile(path, options2);
    }
}